using System;
using System.Collections.Generic;
using System.Text;

using System.Runtime.InteropServices;
namespace OE1
{

    [Guid("E70C92AA-4BFD-11d1-8A95-00C04FB951F3"),
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
    public interface IStoreNamespace
    {
        void Initialize(
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 hwndOwner,
        [In, MarshalAs(UnmanagedType.U4)]  
                Int32 dwReserved);

        void GetDirectory(
        [In, Out, MarshalAs(UnmanagedType.LPStr)]  
                StringBuilder pszPath,
        [In, MarshalAs(UnmanagedType.U4)]  
                Int32 cchMaxPath);

        void OpenSpecialFolder(
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 sfType,
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
        [Out, MarshalAs(UnmanagedType.Interface)]
                out IStoreFolder ppFolder);

        void OpenFolder(
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
        [Out, MarshalAs(UnmanagedType.Interface)]
                out object ppFolder);

        void CreateFolder(
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwParentId,
        [In, MarshalAs(UnmanagedType.LPStr)]  
                String pszName,
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
        [Out, MarshalAs(UnmanagedType.U4)]
                out Int32 pdwFolderId);

        void RenameFolder(
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
        [In, MarshalAs(UnmanagedType.U4)]
                Int32 dwReserved,
        [In, MarshalAs(UnmanagedType.LPStr)]  
                string pszNewName);

        void MoveFolder(
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwParentId,
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved);

        void DeleteFolder(
        [In, MarshalAs(UnmanagedType.U4)] 
                 Int32 dwFolderId,
        [In, MarshalAs(UnmanagedType.U4)] 
                 Int32 dwReserved);

        void GetFolderProps(
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
        [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
        [Out, MarshalAs(UnmanagedType.Struct)] 
                  out _FOLDERPROPS pProps);

        void CopyMoveMessages(
            [In, MarshalAs(UnmanagedType.Interface)]
                object pSource,
            [In, MarshalAs(UnmanagedType.Interface)]
                object pDest,
             [In, MarshalAs(UnmanagedType.Struct)]
                  MESSAGEIDLIST pMsgIdList,
             [In, MarshalAs(UnmanagedType.U4)] 
               Int32 dwFlags,
            [In, MarshalAs(UnmanagedType.U4)] 
               Int32 dwFlagsRemove,
            [In, MarshalAs(UnmanagedType.Interface)]
                object pProgress
            );


        void RegisterNotification(
          [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
          [In, MarshalAs(UnmanagedType.U4)] 
                Int32 hwnd);

        void UnregisterNotification(
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
             [In, MarshalAs(UnmanagedType.U4)] 
                Int32 hwnd);

        void CompactAll(
              [In, MarshalAs(UnmanagedType.U4)] 
                 Int32 dwReserved);

        [PreserveSig]
        Int32 GetFirstSubFolder(
           [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
            [Out, MarshalAs(UnmanagedType.Struct)] 
                  out _FOLDERPROPS pProps,
            [Out, MarshalAs(UnmanagedType.U4)] 
                out Int32 phEnum);


        [PreserveSig]
        Int32 GetNextSubFolder(
            [In, MarshalAs(UnmanagedType.U4)]
                Int32 hEnum,
            [Out, MarshalAs(UnmanagedType.Struct)] 
                  out _FOLDERPROPS pProps);

        void GetSubFolderClose(
        [In, MarshalAs(UnmanagedType.U4)]
                Int32 hEnum);


    }

    [Guid("E70C92AC-4BFD-11d1-8A95-00C04FB951F3"),
    InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
    public interface IStoreFolder
    {

        void GetFolderProps(
           [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
           [Out, MarshalAs(UnmanagedType.Struct)] 
                out _FOLDERPROPS pProps);

        void GetMessageProps(
               [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwMessageId,
                 [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFlags,
                 [In, Out, MarshalAs(UnmanagedType.Struct)] 
                ref _MESSAGEPROPS pProps
                 );

        void FreeMessageProps(
            [In, Out, MarshalAs(UnmanagedType.Struct)] 
                ref _MESSAGEPROPS pProps);


        void DeleteMessages();
        //* [in] */ LPMESSAGEIDLIST pMsgIdList,
        //* [in] */ DWORD dwReserved,
        //* [in] */ IProgressNotify *pProgress) = 0;

        void SetLanguage();
        //* [in] */ DWORD dwLanguage,
        //* [in] */ DWORD dwReserved,
        //* [in] */ LPMESSAGEIDLIST pMsgIdList) = 0;

        void MarkMessagesAsRead();
        //* [in] */ BOOL fRead,
        //* [in] */ DWORD dwReserved,
        //* [in] */ LPMESSAGEIDLIST pMsgIdList) = 0;

        void SetFlags();
        //* [in] */ LPMESSAGEIDLIST pMsgIdList,
        //* [in] */ DWORD dwState,
        //* [in] */ DWORD dwStatemask,
        //* [out] */ LPDWORD prgdwNewFlags) = 0;

        void OpenMessage();
        //* [in] */ MESSAGEID dwMessageId,
        //* [in] */ REFIID riid,
        //* [iid_is][out] */ LPVOID *ppvObject) = 0;

        void SaveMessage();
        //* [in] */ REFIID riid,
        //* [iid_is][in] */ LPVOID pvObject,
        //* [in] */ DWORD dwMsgFlags,
        //* [out] */ LPMESSAGEID pdwMessageId) = 0;

        void BatchLock();
        //* [in] */ DWORD dwReserved,
        //* [out] */ LPHBATCHLOCK phBatchLock) = 0;

        void BatchFlush();
        //* [in] */ DWORD dwReserved,
        //* [in] */ HBATCHLOCK hBatchLock) = 0;

        void BatchUnlock();
        //* [in] */ DWORD dwReserved,
        //* [in] */ HBATCHLOCK hBatchLock) = 0;

        void CreateStream();
        //* [in] */ HBATCHLOCK hBatchLock,
        //* [in] */ DWORD dwReserved,
        //* [out] */ IStream **ppStream,
        //* [out] */ LPMESSAGEID pdwMessageId) = 0;

        void CommitStream();
        //* [in] */ HBATCHLOCK hBatchLock,
        //* [in] */ DWORD dwFlags,
        //* [in] */ DWORD dwMsgFlags,
        //* [in] */ IStream *pStream,
        //* [in] */ MESSAGEID dwMessageId,
        //* [in] */ IMimeMessage *pMessage) = 0;

        void RegisterNotification();
        //* [in] */ DWORD dwReserved,
        //* [in] */ HWND hwnd) = 0;

        void UnregisterNotification();
        //* [in] */ DWORD dwReserved,
        //* [in] */ HWND hwnd) = 0;

        void Compact();
        //* [in] */ DWORD dwReserved) = 0;

        [PreserveSig]
        Int32 GetFirstMessage(
                      [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFlags,
                       [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwMsgFlags,
                       [In, MarshalAs(UnmanagedType.U4)] 
                UInt32 dwMsgIdFirst,
                        [In, Out, MarshalAs(UnmanagedType.Struct)] 
                ref _MESSAGEPROPS pProps,
                       [Out, MarshalAs(UnmanagedType.U4)] 
                out UInt32 phEnum
                       );
        [PreserveSig]
        Int32 GetNextMessage(
           [In, MarshalAs(UnmanagedType.U4)] 
               UInt32 hEnum,
           [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFlags,
            [In, Out, MarshalAs(UnmanagedType.Struct)] 
           ref _MESSAGEPROPS pProps
                         );

        void GetMessageClose(
             [In, MarshalAs(UnmanagedType.U4)] 
                 UInt32 hEnum
            );
    }


    public enum MsgState
    {
        MSG_DELETED = 0x0001,
        MSG_UNREAD = 0x0002,
        MSG_SUBMITTED = 0x0004,
        MSG_UNSENT = 0x0008,
        MSG_RECEIVED = 0x0010,
        MSG_NEWSMSG = 0x0020,
        MSG_NOSECUI = 0x0040,
        MSG_VOICEMAIL = 0x0080,
        MSG_REPLIED = 0x0100,
        MSG_FORWARDED = 0x0200,
        MSG_RCPTSENT = 0x0400,
        MSG_FLAGGED = 0x0800
    }

    public enum IMSGFLAGS
    {
        IMF_ATTACHMENTS = 0x00000001,
        IMF_MULTIPART = 0x00000002,
        IMF_SUBMULTIPART = 0x00000004,
        IMF_MIME = 0x00000008,
        IMF_HTML = 0x00000010,
        IMF_PLAIN = 0x00000020,
        IMF_PARTIAL = 0x00000040,
        IMF_SIGNED = 0x00000080,
        IMF_ENCRYPTED = 0x00000100,
        IMF_TNEF = 0x00000200,
        IMF_MHTML = 0x00000400,
        IMF_SECURE = 0x00000800,
        IMF_TEXT = 0x00001000,
        IMF_CSETTAGGED = 0x00002000,
        IMF_NEWS = 0x00004000,
        IMF_VOICEMAIL = 0x00008000,
        IMF_HASVCARD = 0x00010000,
        IMF_RFC1154 = 0x00020000
    };

    public enum SPECIALFOLDER
    {
        FOLDER_INBOX = 0,
        FOLDER_OUTBOX,
        FOLDER_SENT,
        FOLDER_DELETED,
        FOLDER_DRAFT,
        FOLDER_MAX
    } 	;


    [StructLayout(LayoutKind.Sequential, Pack = 1, CharSet = CharSet.Auto)]
    public struct _MESSAGEPROPS
    {
        public Int32 cbSize;
        public Int32 dwReserved;
        public Int32 dwMessageId;
        public Int32 dwLanguage;
        public Int32 dwState;
        public Int32 cbMessage;
        public Int32 priority;
        public System.Runtime.InteropServices.ComTypes.FILETIME ftReceived;
        public System.Runtime.InteropServices.ComTypes.FILETIME ftSent;

        [MarshalAs(UnmanagedType.LPStr)]
        public string pszSubject;
        [MarshalAs(UnmanagedType.LPStr)]
        public string pszDisplayTo;
        [MarshalAs(UnmanagedType.LPStr)]
        public string pszDisplayFrom;
        [MarshalAs(UnmanagedType.LPStr)]
        public string pszNormalSubject;

        public Int32 dwFlags;
        public Int32 pStmOffsetTable;
    };

    [StructLayout(LayoutKind.Sequential, Pack = 1, CharSet = CharSet.Ansi)]
    public unsafe struct _FOLDERPROPS
    {
        internal Int32 cbSize;
        internal Int32 dwFolderId;
        internal Int32 cSubFolders;
        internal Int32 sfType;
        internal Int32 cUnread;
        internal Int32 cMessage;
        internal fixed byte szName[256];
    } ;
    public struct FOLDERPROPS
    {
        public Int32 cbSize;
        public Int32 dwFolderId;
        public Int32 cSubFolders;
        public Int32 sfType;
        public Int32 cUnread;
        public Int32 cMessage;
        public Int32 hEnum;
        public string szName;

    } ;

    [StructLayout(LayoutKind.Sequential, Pack = 1, CharSet = CharSet.Ansi)]
    public struct MESSAGEIDLIST
    {
        private Int32 cbSize;
        private Int32 cMsgs;
        private Int32[] prgdwMsgId;
    }


    public struct MESSAGEPROPS
    {
        public Int32 MessageId;
        public Int32 Language;
        public MsgState State;
        public Int32 MessageSize;
        public Int32 priority;
        public DateTime Received;
        public DateTime Sent;
        public string Subject;
        public string DisplayTo;
        public string DisplayFrom;
        public string NormalSubject;
        public Int32 Flags;

    };

    public class OE
    {


        public object OECOM;
        public IStoreNamespace OEFolders;
        public OE()
        {
            Type OEType = Type.GetTypeFromCLSID(new Guid("{E70C92A9-4BFD-11d1-8A95-00C04FB951F3}"));
            OECOM = Activator.CreateInstance(OEType);
            OEFolders = OECOM as IStoreNamespace;
            OEFolders.Initialize(0, 0);
        }

        public string getDirectory()
        {
            StringBuilder path = new StringBuilder(256);
            OEFolders.GetDirectory(path, 256);
            return path.ToString();
        }

        public Int32 createFolder(Int32 parentID, string newfoldername)
        {
            Int32 folderID;
            OEFolders.CreateFolder(parentID, newfoldername, 0, out folderID);
            return folderID;
        }

        public void renameFolder(Int32 folderID, string newfoldername)
        {
            OEFolders.RenameFolder(folderID, 0, newfoldername);
        }

        public void moveFolder(Int32 folderID, Int32 parentID)
        {
            OEFolders.MoveFolder(folderID, parentID, 0);
        }
        public void deleteFolder(Int32 folderID)
        {
            OEFolders.DeleteFolder(folderID, 0);
        }


        public FOLDERPROPS GetNextSubFolder(Int32 Id, Int32 hEnum)
        {
            _FOLDERPROPS FP = new _FOLDERPROPS();
            FP.cbSize = Marshal.SizeOf(FP);
            Int32 result;
            if (hEnum == 0)
            {
                result = OEFolders.GetFirstSubFolder(Id, out FP, out hEnum);
            }
            else
            {
                result = OEFolders.GetNextSubFolder(hEnum, out FP);
            }
            FOLDERPROPS fp = transfer(FP);

            if (result != 0)
            {
                if (hEnum != 0) OEFolders.GetSubFolderClose(hEnum);
                hEnum = 0;
            }
            fp.hEnum = hEnum;
            return fp;
        }

        public void GetSubFolderClose(Int32 hEnum)
        {
            OEFolders.GetSubFolderClose(hEnum);

        }

        public OEFolder OpenSpecialFolder(SPECIALFOLDER FolderID)
        {
            IStoreFolder ppFolder;
            OEFolders.OpenSpecialFolder((int)FolderID, 0, out ppFolder);
            OEFolder fold = new OEFolder(ppFolder);

            return fold;

        }

        static public FOLDERPROPS transfer(_FOLDERPROPS FP)
        {
            FOLDERPROPS fp = new FOLDERPROPS();
            fp.cbSize = FP.cbSize;
            fp.cMessage = FP.cMessage;
            fp.cSubFolders = FP.cSubFolders;
            fp.cUnread = FP.cUnread;
            fp.dwFolderId = FP.dwFolderId;
            fp.hEnum = 0;
            fp.sfType = FP.sfType;
            unsafe
            {
                fp.szName = Marshal.PtrToStringAnsi((IntPtr)FP.szName);
            }
            return fp;
        }

    }



    public class OEFolder
    {

        private const UInt32 MESSAGEID_FIRST = 0xffffffff;
        private IStoreFolder m_IFolder;

        public OEFolder(IStoreFolder folder)
        {
            m_IFolder = folder;
        }

        public FOLDERPROPS GetFolderProps()
        {
            _FOLDERPROPS FP = new _FOLDERPROPS();
            FP.cbSize = Marshal.SizeOf(FP);
            m_IFolder.GetFolderProps(0, out FP);
            FOLDERPROPS fp = OE.transfer(FP);

            return fp;
        }

        public MESSAGEPROPS GetNextMessage(ref UInt32 ehandle)
        {
            _MESSAGEPROPS MP = new _MESSAGEPROPS();
            MP.cbSize = Marshal.SizeOf(MP);
            Int32 result = 0;

            if (ehandle == 0)
            {
                result = m_IFolder.GetFirstMessage(0, 0, MESSAGEID_FIRST, ref MP, out ehandle);
            }
            else
            {

                result = m_IFolder.GetNextMessage(ehandle, 0, ref MP);

            }

            MESSAGEPROPS mp = new MESSAGEPROPS();
            if (result == 0)
            {
                mp.MessageId = MP.dwMessageId;
                mp.Language = MP.dwLanguage;
                mp.State = (MsgState)MP.dwState;
                mp.MessageSize = MP.cbMessage;
                mp.priority = MP.priority;
                mp.Received = System.DateTime.FromFileTime(FileTimeToLong(MP.ftReceived));
                mp.Sent = System.DateTime.FromFileTime(FileTimeToLong(MP.ftSent));
                mp.Subject = MP.pszSubject;
                mp.DisplayTo = MP.pszDisplayTo;
                mp.DisplayFrom = MP.pszDisplayFrom;
                mp.NormalSubject = MP.pszNormalSubject;
                mp.Flags = MP.dwFlags;
            }
            else
            {
                m_IFolder.GetMessageClose(ehandle);
            }

            m_IFolder.FreeMessageProps(ref MP);



            return mp;
        }

        private long FileTimeToLong(System.Runtime.InteropServices.ComTypes.FILETIME ftime)
        {

            long h = ((long)ftime.dwHighDateTime) << 32;
            long l = 0xFFFFFFFFL & ftime.dwLowDateTime;

            long t = l | h;
            return t;
        }
    }


}
